/* CDDA.c generated by valac 0.48.7, the Vala compiler
 * generated from CDDA.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include "io.elementary.music-core.h"

#define MUSIC_TYPE_CDDA (music_cdda_get_type ())
#define MUSIC_CDDA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CDDA, MusicCDDA))
#define MUSIC_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CDDA, MusicCDDAClass))
#define MUSIC_IS_CDDA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CDDA))
#define MUSIC_IS_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CDDA))
#define MUSIC_CDDA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CDDA, MusicCDDAClass))

typedef struct _MusicCDDA MusicCDDA;
typedef struct _MusicCDDAClass MusicCDDAClass;
typedef struct _MusicCDDAPrivate MusicCDDAPrivate;
enum  {
	MUSIC_CDDA_0_PROPERTY,
	MUSIC_CDDA_NUM_PROPERTIES
};
static GParamSpec* music_cdda_properties[MUSIC_CDDA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicCDDA {
	GObject parent_instance;
	MusicCDDAPrivate * priv;
};

struct _MusicCDDAClass {
	GObjectClass parent_class;
};

static gpointer music_cdda_parent_class = NULL;
static GType music_cdda_type_id = 0;

GType music_cdda_register_type (GTypeModule * module);
GType music_cdda_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicCDDA, g_object_unref)
#define MUSIC_CDDA_FILE_ATTRIBUTE_TITLE "xattr::org.gnome.audio.title"
#define MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST "xattr::org.gnome.audio.artist"
#define MUSIC_CDDA_FILE_ATTRIBUTE_GENRE "xattr::org.gnome.audio.genre"
#define MUSIC_CDDA_FILE_ATTRIBUTE_DURATION "xattr::org.gnome.audio.duration"
GeeLinkedList* music_cdda_get_media_list (GFile* device_file);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
MusicCDDA* music_cdda_new (void);
MusicCDDA* music_cdda_construct (GType object_type);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

GeeLinkedList*
music_cdda_get_media_list (GFile* device_file)
{
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeLinkedList* result = NULL;
	g_return_val_if_fail (device_file != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	{
		gchar** query_attributes = NULL;
		gchar** _tmp1_;
		gint query_attributes_length1;
		gint _query_attributes_size_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GFileInfo* device_info = NULL;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		gchar* album_name = NULL;
		GFileInfo* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* album_artist = NULL;
		GFileInfo* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* album_genre = NULL;
		GFileInfo* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gboolean valid_album_artist = FALSE;
		const gchar* _tmp25_;
		gboolean valid_album_name = FALSE;
		const gchar* _tmp26_;
		gboolean valid_album_genre = FALSE;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		GFileEnumerator* enumerator = NULL;
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GFileEnumerator* _tmp32_;
		GFileEnumerator* _tmp33_;
		gint index = 0;
		GFileInfo* track_info = NULL;
		_tmp1_ = g_new0 (gchar*, 0 + 1);
		query_attributes = _tmp1_;
		query_attributes_length1 = 0;
		_query_attributes_size_ = query_attributes_length1;
		_tmp2_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
		_vala_array_add1 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp2_);
		_tmp3_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
		_vala_array_add2 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp3_);
		_tmp4_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
		_vala_array_add3 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp4_);
		_tmp5_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
		_vala_array_add4 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp5_);
		_tmp6_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME);
		_vala_array_add5 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp6_);
		_tmp7_ = query_attributes;
		_tmp7__length1 = query_attributes_length1;
		_tmp8_ = _vala_g_strjoinv (",", _tmp7_, (gint) _tmp7__length1);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_query_info (device_file, _tmp9_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		device_info = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			goto __catch0_g_error;
		}
		_tmp12_ = device_info;
		if (_tmp12_ == NULL) {
			g_warning ("CDDA.vala:53: Could not query device attributes");
			result = rv;
			_g_object_unref0 (device_info);
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		_tmp13_ = device_info;
		_tmp14_ = g_file_info_get_attribute_string (_tmp13_, MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
		_tmp15_ = g_strdup (_tmp14_);
		album_name = _tmp15_;
		_tmp16_ = device_info;
		_tmp17_ = g_file_info_get_attribute_string (_tmp16_, MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
		_tmp18_ = g_strdup (_tmp17_);
		album_artist = _tmp18_;
		_tmp19_ = device_info;
		_tmp20_ = g_file_info_get_attribute_string (_tmp19_, MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
		_tmp21_ = g_strdup (_tmp20_);
		album_genre = _tmp21_;
		_tmp22_ = album_name;
		g_message ("CDDA.vala:61: CD ALBUM_NAME: %s", _tmp22_);
		_tmp23_ = album_artist;
		g_message ("CDDA.vala:62: CD ALBUM_ARTIST: %s", _tmp23_);
		_tmp24_ = album_genre;
		g_message ("CDDA.vala:63: CD ALBUM_GENRE: %s", _tmp24_);
		_tmp25_ = album_artist;
		valid_album_artist = music_media_is_valid_string_field (_tmp25_);
		_tmp26_ = album_name;
		valid_album_name = music_media_is_valid_string_field (_tmp26_);
		_tmp27_ = album_genre;
		valid_album_genre = music_media_is_valid_string_field (_tmp27_);
		_tmp28_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
		_vala_array_add6 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp28_);
		_tmp29_ = query_attributes;
		_tmp29__length1 = query_attributes_length1;
		_tmp30_ = _vala_g_strjoinv (",", _tmp29_, (gint) _tmp29__length1);
		_tmp31_ = _tmp30_;
		_tmp32_ = g_file_enumerate_children (device_file, _tmp31_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp33_ = _tmp32_;
		_g_free0 (_tmp31_);
		enumerator = _tmp33_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (album_genre);
			_g_free0 (album_artist);
			_g_free0 (album_name);
			_g_object_unref0 (device_info);
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			goto __catch0_g_error;
		}
		index = 1;
		{
			GFileInfo* _tmp34_ = NULL;
			GFileEnumerator* _tmp35_;
			GFileInfo* _tmp36_;
			GFileInfo* _tmp37_;
			gboolean _tmp38_ = FALSE;
			_tmp35_ = enumerator;
			_tmp36_ = g_file_enumerator_next_file (_tmp35_, NULL, &_inner_error0_);
			_tmp34_ = _tmp36_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (track_info);
				_g_object_unref0 (enumerator);
				_g_free0 (album_genre);
				_g_free0 (album_artist);
				_g_free0 (album_name);
				_g_object_unref0 (device_info);
				query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
				goto __catch0_g_error;
			}
			_tmp37_ = _tmp34_;
			_tmp34_ = NULL;
			_g_object_unref0 (track_info);
			track_info = _tmp37_;
			_tmp38_ = TRUE;
			while (TRUE) {
				GFileInfo* _tmp43_;
				MusicMedia* s = NULL;
				GFileEnumerator* _tmp44_;
				GFile* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				GFileInfo* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				MusicMedia* _tmp52_;
				MusicMedia* _tmp53_;
				MusicMedia* _tmp54_;
				gchar* title = NULL;
				GFileInfo* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* artist = NULL;
				GFileInfo* _tmp64_;
				const gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* genre = NULL;
				GFileInfo* _tmp67_;
				const gchar* _tmp68_;
				gchar* _tmp69_;
				guint64 length = 0ULL;
				GFileInfo* _tmp70_;
				MusicMedia* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				const gchar* _tmp75_;
				const gchar* _tmp76_;
				const gchar* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				MusicMedia* _tmp80_;
				MusicMedia* _tmp81_;
				const gchar* _tmp82_;
				const gchar* _tmp85_;
				const gchar* _tmp88_;
				GeeLinkedList* _tmp91_;
				MusicMedia* _tmp92_;
				gint _tmp93_;
				if (!_tmp38_) {
					GFileInfo* _tmp39_ = NULL;
					GFileEnumerator* _tmp40_;
					GFileInfo* _tmp41_;
					GFileInfo* _tmp42_;
					_tmp40_ = enumerator;
					_tmp41_ = g_file_enumerator_next_file (_tmp40_, NULL, &_inner_error0_);
					_tmp39_ = _tmp41_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (_tmp34_);
						_g_object_unref0 (track_info);
						_g_object_unref0 (enumerator);
						_g_free0 (album_genre);
						_g_free0 (album_artist);
						_g_free0 (album_name);
						_g_object_unref0 (device_info);
						query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
						goto __catch0_g_error;
					}
					_tmp42_ = _tmp39_;
					_tmp39_ = NULL;
					_g_object_unref0 (track_info);
					track_info = _tmp42_;
					_g_object_unref0 (_tmp39_);
				}
				_tmp38_ = FALSE;
				_tmp43_ = track_info;
				if (!(_tmp43_ != NULL)) {
					break;
				}
				_tmp44_ = enumerator;
				_tmp45_ = g_file_enumerator_get_container (_tmp44_);
				_tmp46_ = g_file_get_uri (_tmp45_);
				_tmp47_ = _tmp46_;
				_tmp48_ = track_info;
				_tmp49_ = g_file_info_get_name (_tmp48_);
				_tmp50_ = g_strconcat (_tmp47_, _tmp49_, NULL);
				_tmp51_ = _tmp50_;
				_tmp52_ = music_media_new (_tmp51_);
				_tmp53_ = _tmp52_;
				_g_free0 (_tmp51_);
				_g_free0 (_tmp47_);
				s = _tmp53_;
				_tmp54_ = s;
				music_media_set_is_temporary (_tmp54_, TRUE);
				if (valid_album_artist) {
					MusicMedia* _tmp55_;
					const gchar* _tmp56_;
					_tmp55_ = s;
					_tmp56_ = album_artist;
					music_media_set_album_artist (_tmp55_, _tmp56_);
				}
				if (valid_album_name) {
					MusicMedia* _tmp57_;
					const gchar* _tmp58_;
					_tmp57_ = s;
					_tmp58_ = album_name;
					music_media_set_album (_tmp57_, _tmp58_);
				}
				if (valid_album_genre) {
					MusicMedia* _tmp59_;
					const gchar* _tmp60_;
					_tmp59_ = s;
					_tmp60_ = album_genre;
					music_media_set_genre (_tmp59_, _tmp60_);
				}
				_tmp61_ = track_info;
				_tmp62_ = g_file_info_get_attribute_string (_tmp61_, MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
				_tmp63_ = g_strdup (_tmp62_);
				title = _tmp63_;
				_tmp64_ = track_info;
				_tmp65_ = g_file_info_get_attribute_string (_tmp64_, MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
				_tmp66_ = g_strdup (_tmp65_);
				artist = _tmp66_;
				_tmp67_ = track_info;
				_tmp68_ = g_file_info_get_attribute_string (_tmp67_, MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
				_tmp69_ = g_strdup (_tmp68_);
				genre = _tmp69_;
				_tmp70_ = track_info;
				length = g_file_info_get_attribute_uint64 (_tmp70_, MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
				g_debug ("CDDA.vala:101: TRACK #%d\t:", index);
				_tmp71_ = s;
				_tmp72_ = music_media_get_uri (_tmp71_);
				_tmp73_ = _tmp72_;
				_tmp74_ = _tmp73_;
				g_debug ("CDDA.vala:102:   - TRACK_URI:      %s", _tmp74_);
				_g_free0 (_tmp74_);
				_tmp75_ = title;
				g_debug ("CDDA.vala:103:   - TRACK_TITLE:    %s", _tmp75_);
				_tmp76_ = artist;
				g_debug ("CDDA.vala:104:   - TRACK_ARTIST:   %s", _tmp76_);
				_tmp77_ = genre;
				g_debug ("CDDA.vala:105:   - TRACK_GENRE:    %s", _tmp77_);
				_tmp78_ = g_strdup_printf ("%" G_GUINT64_FORMAT, length);
				_tmp79_ = _tmp78_;
				g_debug ("CDDA.vala:106:   - TRACK_DURATION: %s secs\n", _tmp79_);
				_g_free0 (_tmp79_);
				_tmp80_ = s;
				music_media_set_track (_tmp80_, (guint) index);
				_tmp81_ = s;
				music_media_set_length (_tmp81_, (guint) (length * MUSIC_TIME_UTILS_MILI_INV));
				_tmp82_ = title;
				if (music_media_is_valid_string_field (_tmp82_)) {
					MusicMedia* _tmp83_;
					const gchar* _tmp84_;
					_tmp83_ = s;
					_tmp84_ = title;
					music_media_set_title (_tmp83_, _tmp84_);
				}
				_tmp85_ = artist;
				if (music_media_is_valid_string_field (_tmp85_)) {
					MusicMedia* _tmp86_;
					const gchar* _tmp87_;
					_tmp86_ = s;
					_tmp87_ = artist;
					music_media_set_artist (_tmp86_, _tmp87_);
				}
				_tmp88_ = genre;
				if (music_media_is_valid_string_field (_tmp88_)) {
					MusicMedia* _tmp89_;
					const gchar* _tmp90_;
					_tmp89_ = s;
					_tmp90_ = genre;
					music_media_set_genre (_tmp89_, _tmp90_);
				}
				_tmp91_ = rv;
				_tmp92_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp91_, _tmp92_);
				_tmp93_ = index;
				index = _tmp93_ + 1;
				_g_free0 (genre);
				_g_free0 (artist);
				_g_free0 (title);
				_g_object_unref0 (s);
			}
			_g_object_unref0 (_tmp34_);
		}
		_g_object_unref0 (track_info);
		_g_object_unref0 (enumerator);
		_g_free0 (album_genre);
		_g_free0 (album_artist);
		_g_free0 (album_name);
		_g_object_unref0 (device_info);
		query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp94_;
		const gchar* _tmp95_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp94_ = err;
		_tmp95_ = _tmp94_->message;
		g_warning ("CDDA.vala:136: Could not enumerate CD tracks or access album info: %s", _tmp95_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (rv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = rv;
	return result;
}

MusicCDDA*
music_cdda_construct (GType object_type)
{
	MusicCDDA * self = NULL;
	self = (MusicCDDA*) g_object_new (object_type, NULL);
	return self;
}

MusicCDDA*
music_cdda_new (void)
{
	return music_cdda_construct (MUSIC_TYPE_CDDA);
}

static void
music_cdda_class_init (MusicCDDAClass * klass,
                       gpointer klass_data)
{
	music_cdda_parent_class = g_type_class_peek_parent (klass);
}

static void
music_cdda_instance_init (MusicCDDA * self,
                          gpointer klass)
{
}

GType
music_cdda_get_type (void)
{
	return music_cdda_type_id;
}

GType
music_cdda_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicCDDAClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cdda_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCDDA), 0, (GInstanceInitFunc) music_cdda_instance_init, NULL };
	music_cdda_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicCDDA", &g_define_type_info, 0);
	return music_cdda_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

